Description

SystemMetadataDaoMetacatImpl (in d1_cn_common) sets replication_allowed to false in situations of a null ReplicationPolicy, even

though the CN is not supposed to alter the ReplicationPolicy.

DataONE has historically taken the approach of opting into replicating content, instead of opting-out, so at least the default of false is

in keeping with that.  However, the DAO layer seems to be the wrong place to be applying business rules.  It would be better to put in

d1_synchronization logic.  (and updateSystemMetadata).

Two issues are at play here:

1. should the semantics of a null replicationPolicy be "use the CN default behavior at the time of submission" or "I don't care" -

allowing the CN to add or remove replicas at will."?

If the former, we need to persist a default ReplicationPolicy.  If the latter, we need to remove the addition of a ReplicationPolicy, and

potentially remove default polices based on MN versions of system metadata.

1. should the DAO implemention apply the business rules about default values, or should it be refactored to d1_synchronization

and updateSystemMEtadata?

Related issues:

Related to Infrastructure - Story #8639: Replication performance is too slow ... New 2018-07-04

History

#1 - 2016-02-17 23:26 - Rob Nahf

- Tracker changed from Bug to Story

- Description updated

- Subject changed from DAOaccess for SystemMetadata changes the SystemMetadata.replicationPolicy to DAO for SystemMetadata changes the

SystemMetadata.replicationPolicy

- Priority changed from Urgent to Normal

#2 - 2016-04-19 21:42 - Rob Nahf

- Description updated

DataONE should continue to have "opt-in" semantics, and so it is proper for the CN to populate a default replication policy if none is provided, and set

replication_allowed to false.

What is the impact of refactoring?  maybe there's a good central place where "null defaults" can be set...

#3 - 2016-04-19 22:18 - Rob Nahf

- Assignee set to Rob Nahf

#4 - 2016-04-19 22:40 - Chris Jones

Just as a side note, the SystemMetadataDAOMetacatImpl, IIRC, was originally written for the d1_tidy process when we needed to clean up system

metadata across CNs.  Perhaps it was adopted into d1_cn_common, and some of the policy decisions that were meant for the tidy process were
pulled in too, perhaps inadvertently.

#5 - 2016-05-24 17:53 - Robert Waltz

- Target version changed from CCI-2.2.0 to Release Backlog

#6 - 2016-06-13 23:13 - Rob Nahf

- Description updated

#7 - 2018-01-17 19:31 - Dave Vieglais

- Sprint set to Infrastructure backlog

#8 - 2018-07-04 11:19 - Dave Vieglais

- Related to Story #8639: Replication performance is too slow to service demand added
